/* $Id: DCUPComponentManagerRMISkeleton.java,v 1.5 2002/10/08 16:14:12 hnetynka Exp $ */
package SOFA.Connector.Boot;

import SOFA.Connector.*;
import SOFA.Component.*;
import SOFA.Component.DCUP.*;
import SOFA.SOFAnode.Run.*;
import java.rmi.*;
import java.rmi.server.*;

public class DCUPComponentManagerRMISkeleton extends UnicastRemoteObject implements CNDCUPComponentManagerRemoteInterface, Linkable {

  private CNDCUPComponentManagerInterface tgt = null;

  public DCUPComponentManagerRMISkeleton(String name) throws RemoteException {
    super();
    try {
      java.rmi.Naming.rebind(name, this);
    } catch (Exception e) {
      throw new RemoteException("Can't create DCUPComponentManagerRMISkeleton", e) ;
    }
  }

  public void link(Object target) {
    tgt = (CNDCUPComponentManagerInterface) target;
  }

  public void createComponent(Storage stateStore) throws ComponentLifecycleException, RemoteException {
    tgt.createComponent(stateStore);
  }

  public void destroyComponent(Storage stateStore) throws ComponentLifecycleException, RemoteException {
    tgt.destroyComponent(stateStore);
  }

  public void storeComponent(Storage stateStore) throws ComponentLifecycleException, RemoteException {
    tgt.storeComponent(stateStore);
  }

  public void restoreComponent(Storage stateStore) throws ComponentLifecycleException, RemoteException {
    tgt.restoreComponent(stateStore);
  }


  public void updateComponent( byte[] newDeploymentDescriptor, Storage stateStore) throws ComponentLifecycleException, RemoteException {
    SOFA.SOFAnode.Run.Deployment.DeploymentDescriptorImpl ddr = new SOFA.SOFAnode.Run.Deployment.DeploymentDescriptorImpl();
    try {
      ddr._read(new cz.cuni.sofa.lib.Impl.ByteArrayInputStream(newDeploymentDescriptor));
    } catch (java.io.IOException e) {
      throw new ConnectorTransportException("Can't serialize in the \"updateComponent\".", e);
    }

    tgt.updateComponent(ddr, stateStore);
  }

  public void registerSubcomponent(java.lang.String name, byte[] target) throws SOFA.Component.NamingException, SOFA.Component.InstantiationException, RemoteException {
    SOFA.Connector.Reference ref = new SOFA.Connector.Reference();
    try {
      ref._read(new cz.cuni.sofa.lib.Impl.ByteArrayInputStream(target));
    } catch (java.io.IOException e) {
      throw new ConnectorTransportException("Can't serialize in the \"registerSubcomponent\".", e);
    }

    tgt.registerSubcomponent(name, ref);
  }
  
  public void unregisterSubcomponent(java.lang.String name) throws SOFA.Component.NamingException, RemoteException {
    tgt.unregisterSubcomponent(name);
  }
  
  public byte[] getProvisionReference(String name) throws SOFA.Component.NamingException, RemoteException {
    SOFA.Connector.Reference ref = tgt.getProvisionReference(name);
    
    ref = DeplDockRMISkel.removeLocal(ref);
    cz.cuni.sofa.lib.Impl.ByteArrayOutputStream os = null;
    try {
      os = new cz.cuni.sofa.lib.Impl.ByteArrayOutputStream();
      ref._write(os);
    } catch (java.io.IOException e) {
      throw new ConnectorTransportException("Can't serialize in the \"getProvisionReference\".", e);
    }
    return os.toByteArray();
  }
  
  public void setRequirement(String name, byte[] ref) throws SOFA.Component.InstantiationException, SOFA.Component.NamingException, RemoteException {
    SOFA.Connector.Reference rref = new SOFA.Connector.Reference();
    try {
      rref._read(new cz.cuni.sofa.lib.Impl.ByteArrayInputStream(ref));
    } catch (java.io.IOException e) {
      throw new ConnectorTransportException("Can't serialize in the \"registerSubcomponent\".", e);
    }
    tgt.setRequirement(name, rref);
  }
  
  public void connectSubsumable() throws SOFA.Component.NamingException, SOFA.Component.InstantiationException, RemoteException {
    tgt.connectSubsumable();
  }

  public SOFA.SOFAnode.Run.Deployment.DeplDock getLocalDeplDock() {
    return null;
  }

  public String getFullName() {
    return tgt.getFullName();
  }

  public boolean isUpdatable() {
    return tgt.isUpdatable();
  }

}
