/*
 * VariableExpander.java
 *
 * Created on 6. duben 2002, 9:43
 */

package SOFA.Connector.ECG;

/**
 *
 * @author  ghort
 * @version 
 */
public class VariableExpander {

	protected java.util.HashMap subst;
	
	/** Creates new VariableExpander */
	public VariableExpander() {
		subst=new java.util.HashMap();
	}

	public void addSubst(String var, String value) throws VariableExpanderAmbiguityException {
		String prev;
		prev=(String)subst.get(var);
		if (prev!=null) {
			if (!prev.equals(value)) {
				throw new VariableExpanderAmbiguityException("Duplicate and ambiguious definition of variable '"+var+"'.");
			}
		} else {
			subst.put(var,value);
		}
	}
	
	public String expand(String name) throws VariableExpanderUnresolvedNameException {
		int i, start, end, len=name.length();
		StringBuffer str=new StringBuffer();
		String inStr;

		for (i=0;i<len;i++) {
			start=name.indexOf('{',i);

			if (start==-1 || !(start<len-2 && (end=name.indexOf('}',start+2))!=-1)) {
				str.append(name.substring(i));
				break;
			} else if (start>0) {
				str.append(name.substring(i,start));
			}

			i=end;
			
			inStr=name.substring(start+1,end);
			if ((end=inStr.lastIndexOf(':'))==-1 || end==inStr.length()-1) {
				String val=(String)subst.get(inStr);
				str.append(val);
			} else {
				String val=(String)subst.get(inStr.substring(end+1));
				String prefix=inStr.substring(0,end);
				
				end=val.lastIndexOf('.');
				if (end!=-1) {
					str.append(val.substring(0,end+1));
				}
				str.append(prefix);
				if (end<val.length()-1) {
					str.append(val.substring(end+1));
				}
			}
		}
		return str.toString();
	}

	static public String extractVariable(String name) {
		try {
			byte[] varName=name.getBytes();
			
			if (varName.length>2 && varName[0]=='{' && varName[varName.length-1]=='}') {
				int i;
				
				for (i=1;i<varName.length-2;i++) {
					if (varName[i]=='}') {
						return null;
					}
				}
			}
			return name.substring(1,name.length()-1);
		} catch (ArrayIndexOutOfBoundsException e) {
			return null;
		} catch (IndexOutOfBoundsException e) {
			return null;
		}
	}
	
}
