/*
 * RMIStubGen.java
 *
 * Created on 13. duben 2002, 21:08
 */

package SOFA.Connector.EEG.EEM.Elements;

import SOFA.SOFAnode.Made.TIR.*;
import SOFA.SOFAnode.Made.TIR.Access.TIRAccessMethods;
import SOFA.Connector.EEG.CodeWriter.*;
import SOFA.Connector.EEG.EEM.Actions.*;

/**
 *
 * @author  ghort
 * @version 
 */
public class RMIStubGen extends JImplWriterDirectorBase {

	/** Creates new RMIStubGen */
	public RMIStubGen(String provIfaceCDL, SOFA.Connector.Property[] params) {
		super(provIfaceCDL,params);
	}

	public String[] getImplements() {
		return new String[] {"SOFA.Connector.EEG.Types.Stub"};
	}
	
	public String getClassBody() {
		String reqIfaceMapped=SOFA.Connector.Property.findFirst(params,"reqIfaceMapped");
		return managerTieImpl() + "\n" +
			"\tprotected "+reqIfaceMapped+" target;\n\n"+
			"\tpublic void link(SOFA.Connector.TaggedProfile target) throws SOFA.Connector.LinkException {\n"+
			"\t\ttry {\n"+
			"\t\t\tthis.target=("+reqIfaceMapped+")java.rmi.Naming.lookup(((SOFA.Connector.ECG.Profiles.RMIProfile)target).URL);\n"+
			"\t\t} catch (Exception e) {\n"+
			"\t\t\tthrow new SOFA.Connector.LinkException(\"Can't link to '\"+((SOFA.Connector.ECG.Profiles.RMIProfile)target).URL+\"'.\",e);\n"+
			"\t\t}\n"+
			"\t}\n\n"+
			"\tpublic String[] getSupportedProfiles() {\n"+
			"\t\treturn new String[] {\"RMI\"};\n"+
			"\t}\n";
	}
	
	public String getMethodDef(OperationDef mt) throws JWriterDirectorException {
		return JIfaceCN.getMethodDef(mt);
	}
	
	public String getMethodBody(OperationDef method) throws JWriterDirectorException {
		try {
			return
				"\t\ttry {\n"+
				"\t\t\t"+declareRet(method,"ret")+"\n"+
				"\t\t\t"+assignRet(method,"ret")+targetCall(method,JIfaceCNRMI.targetCallParams(method))+";\n"+
				"\t\t\t"+returnRet(method,"ret")+"\n"+
				"\t\t} catch (java.rmi.RemoteException e) {\n"+
				"\t\t\tthrow new SOFA.Connector.ConnectorTransportException(\"Can't call method '"+method.get_identification().absolute_name().name()+"'.\",e);\n"+
				"\t\t}\n";
		} catch (java.rmi.RemoteException e) {
			throw new JWriterDirectorException("Cannot access TIR.",e);
		}
	}
}
