/*
 * ElementInputDescriptor.java
 *
 * Created on 2. duben 2002, 20:31
 */

package SOFA.Connector.EEG;

import org.w3c.dom.*;

/**
 *
 * @author  ghort
 * @version 
 */
public class ElementInputDescriptor {

	public String instanceName;
	public String implementation;
	
	public SOFA.Connector.Property[] props;

	public SOFA.Connector.Property[] techProps; // mozna tohle do props
		
	/** Creates new ElementInputDescriptor */
	public ElementInputDescriptor() {
	}

	static public ElementInputDescriptor fromXML(Element rootElement) throws ElementDescriptorXMLException {
		ElementInputDescriptor eid=new ElementInputDescriptor();
		java.util.LinkedList descrProps=new java.util.LinkedList();
		Node node;

		if (!rootElement.hasAttribute("name")) {
			throw new ElementDescriptorXMLException("Element doesn't have 'name' attribute.");
		}
		eid.instanceName=rootElement.getAttribute("name");

		if (!rootElement.hasAttribute("impl")) {
			throw new ElementDescriptorXMLException("Element doesn't have 'impl' attribute.");
		}
		eid.implementation=rootElement.getAttribute("impl");
		
		node=rootElement.getFirstChild();
		while (node!=null) {
			if (node.getNodeType()==Node.ELEMENT_NODE) {
				Element el=(Element)node;
				if (el.getNodeName().equals("property") && el.hasAttribute("name") && el.hasAttribute("value")) {
					descrProps.add(new SOFA.Connector.Property(el.getAttribute("name"),el.getAttribute("value")));
				} 
			}
			node=node.getNextSibling();
		}
		
		eid.techProps=new SOFA.Connector.Property[0]; // FIXME: mela by se nacitat take z XML

		eid.props=new SOFA.Connector.Property[descrProps.size()];
		java.util.Iterator iter=descrProps.iterator();
		for (int i=0;iter.hasNext();i++) {
			eid.props[i]=(SOFA.Connector.Property)iter.next();
		}
		
		return eid;
	}
}
