/* $Id: Interactive.java,v 2.0 2002/02/15 13:54:52 hnetynka Exp $ */
package SOFA.SOFAnode.Made.CDL;
import java.io.*;

/** Class for ineraction with user */
public class Interactive {
  static BufferedReader input;
  
  static {
    input = new BufferedReader(new InputStreamReader(System.in));
  }

  /** read line from std input */
  static public String readLine() throws IOException {
    return input.readLine();
  }

  /** write line to std output */
  static public void writeLine(String line) {
    Output.out.println(line);
  }

  /** write string to std output */
  static public void write(String line) {
    Output.out.print(line);
  }

  /** ask yes or no */
  static public boolean askYesNo(String message, boolean strong, String strongMessage) {
    try {
      System.out.print(message+" (y/N): ");
      String answer = input.readLine();
      answer = answer.trim();
      if (answer.compareTo("")==0) 
        return false;
      if (answer.compareTo("y")==0) {
        if (strong) {
          System.out.print(strongMessage+" (y/N): ");
          answer = input.readLine();
          answer = answer.trim();
          if (answer.compareTo("")==0) 
            return false;
          if (answer.compareTo("y")==0)
            return true;
          return false;
        }
        return true;
      }
      return false;
    } catch (IOException e) {
      return false;
    }
  }
}
