/* $Id: CDLRepository.java,v 2.0 2002/02/15 13:55:05 hnetynka Exp $ */
package SOFA.SOFAnode.Made.TIR;
import java.rmi.RemoteException;

/** Repository interface for the CDL. */
public interface CDLRepository extends  CDLContainer, Contained {
  /** Returns PrimitiveDef object with specified kind. */
  public PrimitiveDef get_primitive(int kind) throws RemoteException, TIRExceptCreate;

  /** Create new string type. */
  public StringDef    create_string(ExprOperDef bound) throws RemoteException, TIRExceptCreate;
  /** Create new wstring type. */
  public WstringDef   create_wstring(ExprOperDef bound) throws RemoteException, TIRExceptCreate;
  /** Create new sequence type. */
  public SequenceDef  create_sequence(ExprOperDef bound, CDLType element) throws RemoteException, TIRExceptCreate;
  /** Create new array type. */
  public ArrayDef     create_array(ExprOperDef length, CDLType element) throws RemoteException, TIRExceptCreate;
  /** Create new fixed type. */
  public FixedDef     create_fixed(ExprOperDef digits, ExprOperDef scale) throws RemoteException, TIRExceptCreate;

  /** Create new Provider object in the Repository. */
  public ProviderDef  create_provider(Identification id) throws RemoteException, TIRExceptCreate, TIRExceptLock;


}
