/* $Id: Container.java,v 2.0 2002/02/15 13:55:06 hnetynka Exp $ */
package SOFA.SOFAnode.Made.TIR;
import java.rmi.RemoteException;

/** The base interface <i>Container</i> is extended by all <b>TIR</b> objects that 
    contain other <b>TIR</b> objects.
*/
public interface Container extends TIRObject {
  /** Search object with this identification in this conatiner. */
  public Contained   lookup(Identification id) throws RemoteException, TIRExceptLock;
  /** Search object with this name and version in this conatiner. */
  public Contained   lookup(String name, String version) throws RemoteException, TIRExceptLock;
  /** Search objects with same name, they haven't to have same version. */
  public Contained[] lookup_name(Identification id) throws RemoteException, TIRExceptLock;
  /** Search objects with same name, they haven't to have same version. */
  public Contained[] lookup_name(String name) throws RemoteException, TIRExceptLock;
  /** Returns all objects with specified kind in this container. */
  public Contained[] contents(DefinitionKind type) throws RemoteException, TIRExceptLock;

  /** Search objects with specified tag this container. */
  public Contained lookup_tag(String name, String tag) throws RemoteException, TIRExceptLock;
  /** Search objects from same branch this container.
      (if (brtag==null || brtag=="") search in main branch. */
  public Contained[] lookup_branchtag(String name, String brtag) throws RemoteException, TIRExceptLock;
  /** Search object with this name, which is last version in specified branch. 
      (if (brtag==null || brtag=="") search in main branch. */
  public Contained lookup_lastinbranch(String name, String brtag) throws RemoteException, TIRExceptLock;
  /** Search object with this name, which is last version in branch, in
      which is object with this version */
  public Contained lookup_lastfromversion(String name, String version) throws RemoteException, TIRExceptLock;
}
