/* $Id: FrameDef.java,v 2.0 2002/02/15 13:55:10 hnetynka Exp $ */
package SOFA.SOFAnode.Made.TIR;
import java.rmi.RemoteException;

/** Interface for the frame */
public interface FrameDef extends Contained, Container, CDLType {
  /** Returns <b>true</b> if architecture was declared <i>system</i> */
  public boolean is_system() throws RemoteException;

  /** protocol of this frame */
  public ProtocolDef protocol() throws RemoteException;

  /** Create requirement object in this frame */
  public RequireDef create_require(String name, CDLType type) throws RemoteException, TIRExceptCreate, TIRExceptLock;
  /** Create provision object in this frame */
  public ProvideDef create_provide(String name, CDLType type) throws RemoteException, TIRExceptCreate, TIRExceptLock;
  /** Create property object in this frame */
  public PropertyDef create_property(String name, CDLType type) throws RemoteException, TIRExceptCreate, TIRExceptLock;
  /** Create protocol */
  public ProtocolDef create_protocol() throws RemoteException, TIRExceptCreate, TIRExceptLock;
}
