/* $Id: AttrModeImpl.java,v 2.0 2002/02/15 13:55:26 hnetynka Exp $ */
package SOFA.SOFAnode.Made.TIR.Impl;
import SOFA.SOFAnode.Made.TIR.*;
import java.rmi.Remote;
import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;
import java.io.IOException;

public class AttrModeImpl extends UnicastRemoteObject implements AttrMode, TIRImplObject {
  int m;

  public AttrModeImpl(int mode) throws RemoteException {
    m = mode;
  }

  public AttrModeImpl() throws RemoteException {
    m = 0;
  }

  public int value() throws RemoteException {
    return m;
  }

  /*from interface TIRImplObject */
  public void load(Storage st) throws RemoteException, TIRExceptStorage {
    try {
      m = st.curInFile.readInt();
    } catch (IOException e) {
      throw new TIRExceptStorage("Can't read in file "+st.currentFile+".");
    }
  }

  /*from interface TIRImplObject */
  public void save(Storage st) throws RemoteException, TIRExceptStorage {
    try {
      st.curOutFile.writeInt(m);
    } catch (IOException e) {
      throw new TIRExceptStorage("Can't write in file "+st.currentFile+".");
    }  
  }
  
  public void postLoad(RepositoryImpl r) throws RemoteException, TIRExceptStorage {
    ;
  }

  public boolean isNew() {
    return false;
  }

  public void canCommit() throws RemoteException, TIRExceptCommit {;}
  public void doCommit(Container in, Repository rep) throws RemoteException {;}
  public void doAbort(long workId) throws RemoteException {}
}
