/* $Id: NotYetInRep.java,v 2.0 2002/02/15 13:55:33 hnetynka Exp $ */
package SOFA.SOFAnode.Made.TIR.Impl;
import SOFA.SOFAnode.Made.TIR.*;
import java.rmi.Remote;
import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;

public class NotYetInRep implements CDLType {
  DefinitionKindImpl defKindImpl;   /* this */
  
  public int defKind;                /* dk_Typedef or dk_Primitive */
  public IdentificationImpl id;
  public AbsoluteNameImpl nm;
  public int primKind;

  public NotYetInRep(String absname, String name, String version) throws RemoteException {
    defKindImpl = new DefinitionKindImpl(DefinitionKind.dk_none);
    defKind = DefinitionKind.dk_Typedef;
    nm = new AbsoluteNameImpl(absname);
    StringBuffer sb = new StringBuffer();
    for(int i=1;i<nm.size();i++) {
      sb.append("::"+nm.elementAt(i));
    }
    id = new IdentificationImpl(nm.elementAt(0), sb.toString(), version);
    primKind = -1;
  }

  public NotYetInRep(int primitiveKind) throws RemoteException {
    defKindImpl = new DefinitionKindImpl(DefinitionKind.dk_none);
    defKind = DefinitionKind.dk_Primitive;
    primKind = primitiveKind;
    id = null;
    nm = null;
  }

  /* from interface TIRObject */
  public DefinitionKind get_def_kind() throws RemoteException {
    return (DefinitionKind) defKindImpl;
  }

  /* from interface TIRObject */
  public StateKind get_state() throws RemoteException {
    return null;
  }
}
