/* $Id: ProtocolUpdateStripped.java,v 2.1 2002/05/01 13:10:59 visnovsky Exp $ */

package SOFA.SOFAnode.Util;

import java.util.*;

class ProtocolUpdateStripped extends ProtocolOperator {

    protected Protocol nested;

    public ProtocolUpdateStripped( Protocol l ) {
	super( "=U'" ); // FIXME: something reasonable
	nested = l;
    }
    
    public Protocol Copy() {
	return new ProtocolUpdateStripped( nested.Copy());
    }
    
    public Machine createMachine() {
        
	Machine m1 = nested.createMachine();
        
	m1.StrippedUpdateOnly();

	return m1;
    }
    
    public boolean Restrict( ActionTokenArray a ) {
	ActionTokenArray h = new ActionTokenArray( a );
	h.tokens[1]=true; // [UPDATE] must survive the restriction
	return nested.Restrict( h );
    }

    public void Print( int level ) {
	Debug.println( level, "Stripped update behavior");
	nested.Print( level );
    }

    public Protocol Left() {
	return nested;
    }

    public Protocol getSameType( Object p1, Object p2 ) {
	return new ProtocolUpdateStripped( (Protocol)p1 );
    }
}
