/* $Id: CORBAAccess.java,v 1.1 2002/06/24 22:24:40 hnetynka Exp $ */
package SOFA.Util;

import org.omg.CORBA.*;
import org.omg.PortableServer.*;
import org.omg.CosNaming.*;

/** Contains reference to ORB, naming,...
  *
  * @author Petr Hnetynka
  */
public class CORBAAccess {
 
  
  public static ORB orb;
  public static NamingContext ncRef;
  private static POA rootpoa;


  public CORBAAccess() throws CORBAAccessException {
 
    try {
      String orbport = System.getProperty("sofa.orbport","900");
      String orbhost = System.getProperty("sofa.orbhost","localhost");
      String[] args = new String [4];
      args[0] = "-ORBInitialPort";
      args[1] = orbport;
      args[2] = "-ORBInitialHost";
      args[3] = orbhost;
      
      orb = ORB.init(args, null);

      rootpoa=POAHelper.narrow(orb.resolve_initial_references("RootPOA"));
      rootpoa.the_POAManager().activate();

      org.omg.CORBA.Object objRef = orb.resolve_initial_references("NameService");
      ncRef = NamingContextHelper.narrow(objRef);

    }
    catch (Exception e) {
      throw new CORBAAccessException("Can't initialize ORB.", e);
    }
  }   

  public static org.omg.CORBA.Object activate_object(Servant o) throws Exception {
    return rootpoa.servant_to_reference(o);
  }

  public static String object_to_string(org.omg.CORBA.Object o) throws Exception {

    return orb.object_to_string((org.omg.CORBA.Object)o);
  }

  public void run() {
    orb.run();
  }
}
